package com.dzeio.openhealth.services

import android.app.job.JobParameters
import android.app.job.JobService
import android.content.Context
import android.hardware.Sensor
import android.hardware.SensorEvent
import android.hardware.SensorEventListener
import android.hardware.SensorManager
import android.util.Log

class StepCountService : JobService(), SensorEventListener {
    override fun onStartJob(params: JobParameters?): Boolean {
        Log.d("StepCountService", "Service Started")
        val sensorManager = getSystemService(Context.SENSOR_SERVICE) as SensorManager
        val stepCountSensor = sensorManager.getDefaultSensor(Sensor.TYPE_STEP_COUNTER)
        stepCountSensor.let {
            sensorManager.registerListener(this, it, SensorManager.SENSOR_DELAY_NORMAL)
        }
        return true
    }

    override fun onStopJob(params: JobParameters?): Boolean {
        Log.d("StepCountService", "Service Stopped :(")
        return true
    }

    override fun onAccuracyChanged(sensor: Sensor?, accuracy: Int) {
        Log.d("StepCountService", "Accuracy changed $sensor, $accuracy")
    }

    override fun onSensorChanged(event: SensorEvent?) {
        event?.let {
            Log.d("StepCountService", "Event Triggered: $it")
            it.values.firstOrNull()?.let { value ->
                Log.d("StepCountService", "Step Count $value")
            }
        }
    }
}